Index: codes/icosagcm/trunk/src/base/field.f90
===================================================================
--- codes/icosagcm/trunk/src/base/field.f90	(revision 962)
+++ codes/icosagcm/trunk/src/base/field.f90	(revision 963)
@@ -13,7 +13,7 @@
   TYPE t_field
     CHARACTER(30)      :: name
-    REAL(rstd),POINTER :: rval2d(:) => null()
-    REAL(rstd),POINTER :: rval3d(:,:) => null()
-    REAL(rstd),POINTER :: rval4d(:,:,:) => null()
+    REAL(rstd),POINTER, CONTIGUOUS :: rval2d(:) => null()
+    REAL(rstd),POINTER, CONTIGUOUS :: rval3d(:,:) => null()
+    REAL(rstd),POINTER, CONTIGUOUS :: rval4d(:,:,:) => null()
 
     INTEGER,POINTER :: ival2d(:)
@@ -274,79 +274,78 @@
        IF (field(ind)%ndim==4) THEN
           IF (data_type==type_integer) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%ival4d(:,:,:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%ival4d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%ival4d)
-                CONTINUE
-             END IF
           END IF
 
           IF (data_type==type_real) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%rval4d(:,:,:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%rval4d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%rval4d)
-                CONTINUE
-             END IF
           END IF
 
           IF (data_type==type_logical) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%lval4d(:,:,:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%lval4d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%lval4d)
-                CONTINUE
-             END IF
           END IF
 
        ELSE IF (field(ind)%ndim==3) THEN
           IF (data_type==type_integer) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%ival3d(:,:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%ival3d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%ival3d)
-                CONTINUE
-             END IF
           END IF
 
           IF (data_type==type_real) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%rval3d(:,:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%rval3d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%rval3d)
-                CONTINUE
-             END IF
           END IF
 
           IF (data_type==type_logical) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%lval3d(:,:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%lval3d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%lval3d)
-                CONTINUE
-             END IF
           END IF
 
        ELSE IF (field(ind)%ndim==2) THEN
           IF (data_type==type_integer) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%ival2d(:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%ival2d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%ival2d)
-                CONTINUE
-             END IF
           END IF
 
           IF (data_type==type_real) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%rval2d(:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%rval2d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%rval2d)
-                CONTINUE
-             END IF
           END IF
 
           IF (data_type==type_logical) THEN
+             IF (field(ind)%ondevice) THEN
+                !$acc exit data delete(field(ind)%lval2d(:))
+                CONTINUE
+             END IF
              DEALLOCATE(field(ind)%lval2d)
-             IF (field(ind)%ondevice) THEN
-                !$acc exit data delete(field(ind)%lval2d)
-                CONTINUE
-             END IF
           END IF
 
        ENDIF
-
     ENDDO
   END SUBROUTINE deallocate_field_
@@ -555,15 +554,15 @@
       IF (field(ind)%ndim==4) THEN
          IF (field(ind)%data_type==type_integer) THEN
-            !$acc update device(field(ind)%ival4d(:,:,:))
+            !$acc update device(field(ind)%ival4d(:,:,:)) async
             CONTINUE
          END IF
 
          IF (field(ind)%data_type==type_real) THEN
-            !$acc update device(field(ind)%rval4d(:,:,:))
+            !$acc update device(field(ind)%rval4d(:,:,:)) async
             CONTINUE
          END IF
 
          IF (field(ind)%data_type==type_logical) THEN
-            !$acc update device(field(ind)%lval4d(:,:,:))
+            !$acc update device(field(ind)%lval4d(:,:,:)) async
             CONTINUE
          END IF
@@ -571,15 +570,15 @@
       ELSE IF (field(ind)%ndim==3) THEN
          IF (field(ind)%data_type==type_integer) THEN
-            !$acc update device(field(ind)%ival3d(:,:))
+            !$acc update device(field(ind)%ival3d(:,:)) async
             CONTINUE
          END IF
 
          IF (field(ind)%data_type==type_real) THEN
-            !$acc update device(field(ind)%rval3d(:,:))
+            !$acc update device(field(ind)%rval3d(:,:)) async
             CONTINUE
          END IF
 
          IF (field(ind)%data_type==type_logical) THEN
-            !$acc update device(field(ind)%lval3d(:,:))
+            !$acc update device(field(ind)%lval3d(:,:)) async
             CONTINUE
          END IF
@@ -587,15 +586,15 @@
       ELSE IF (field(ind)%ndim==2) THEN
          IF (field(ind)%data_type==type_integer) THEN
-            !$acc update device(field(ind)%ival2d(:))
+            !$acc update device(field(ind)%ival2d(:)) async
             CONTINUE
          END IF
 
          IF (field(ind)%data_type==type_real) THEN
-            !$acc update device(field(ind)%rval2d(:))
+            !$acc update device(field(ind)%rval2d(:)) async
             CONTINUE
          END IF
 
          IF (field(ind)%data_type==type_logical) THEN
-            !$acc update device(field(ind)%lval2d(:))
+            !$acc update device(field(ind)%lval2d(:)) async
             CONTINUE
          END IF
@@ -616,34 +615,34 @@
 
       IF (field(ind)%ondevice) THEN
-        
+
          IF (field(ind)%ndim==4) THEN
             IF (field(ind)%data_type==type_integer) THEN
-               !$acc update host(field(ind)%ival4d(:,:,:)) wait
+               !$acc update host(field(ind)%ival4d(:,:,:)) async
                CONTINUE
             END IF
 
             IF (field(ind)%data_type==type_real) THEN
-               !$acc update host(field(ind)%rval4d(:,:,:)) wait
+               !$acc update host(field(ind)%rval4d(:,:,:)) async
                CONTINUE
             END IF
 
             IF (field(ind)%data_type==type_logical) THEN
-               !$acc update host(field(ind)%lval4d(:,:,:)) wait
-               CONTINUE
-            END IF
-         
+               !$acc update host(field(ind)%lval4d(:,:,:)) async
+               CONTINUE
+            END IF
+
          ELSE IF (field(ind)%ndim==3) THEN
             IF (field(ind)%data_type==type_integer) THEN
-               !$acc update host(field(ind)%ival3d(:,:)) wait
+               !$acc update host(field(ind)%ival3d(:,:)) async
                CONTINUE
             END IF
 
             IF (field(ind)%data_type==type_real) THEN
-               !$acc update host(field(ind)%rval3d(:,:)) wait
+               !$acc update host(field(ind)%rval3d(:,:)) async
                CONTINUE
             END IF
 
             IF (field(ind)%data_type==type_logical) THEN
-               !$acc update host(field(ind)%lval3d(:,:)) wait
+               !$acc update host(field(ind)%lval3d(:,:)) async
                CONTINUE
             END IF
@@ -651,15 +650,15 @@
          ELSE IF (field(ind)%ndim==2) THEN
             IF (field(ind)%data_type==type_integer) THEN
-               !$acc update host(field(ind)%ival2d(:)) wait
+               !$acc update host(field(ind)%ival2d(:)) async
                CONTINUE
             END IF
 
             IF (field(ind)%data_type==type_real) THEN
-               !$acc update host(field(ind)%rval2d(:)) wait
+               !$acc update host(field(ind)%rval2d(:)) async
                CONTINUE
             END IF
 
             IF (field(ind)%data_type==type_logical) THEN
-               !$acc update host(field(ind)%lval2d(:)) wait
+               !$acc update host(field(ind)%lval2d(:)) async
                CONTINUE
             END IF
@@ -667,4 +666,5 @@
       END IF
    ENDDO
+   !$acc wait
    !$OMP BARRIER
  END SUBROUTINE update_host_field
@@ -679,39 +679,39 @@
     IF (field%ndim==4) THEN
        IF (field%data_type==type_integer) THEN
-          !$acc enter data create(field%ival4d(:,:,:))
+          !$acc enter data create(field%ival4d(:,:,:)) async
        END IF
 
        IF (field%data_type==type_real) THEN
-          !$acc enter data create(field%rval4d(:,:,:))
+          !$acc enter data create(field%rval4d(:,:,:)) async
        END IF
 
        IF (field%data_type==type_logical) THEN
-          !$acc enter data create(field%lval4d(:,:,:))
+          !$acc enter data create(field%lval4d(:,:,:)) async
        END IF
 
     ELSE IF (field%ndim==3) THEN
        IF (field%data_type==type_integer) THEN
-          !$acc enter data create(field%ival3d(:,:))
+          !$acc enter data create(field%ival3d(:,:)) async
        END IF
 
        IF (field%data_type==type_real) THEN
-          !$acc enter data create(field%rval3d(:,:))
+          !$acc enter data create(field%rval3d(:,:)) async
        END IF
 
        IF (field%data_type==type_logical) THEN
-          !$acc enter data create(field%lval3d(:,:))
+          !$acc enter data create(field%lval3d(:,:)) async
        END IF
 
     ELSE IF (field%ndim==2) THEN
        IF (field%data_type==type_integer) THEN
-          !$acc enter data create(field%ival2d(:))
+          !$acc enter data create(field%ival2d(:)) async
        END IF
 
        IF (field%data_type==type_real) THEN
-          !$acc enter data create(field%rval2d(:))
+          !$acc enter data create(field%rval2d(:)) async
        END IF
 
        IF (field%data_type==type_logical) THEN
-          !$acc enter data create(field%lval2d(:))
+          !$acc enter data create(field%lval2d(:)) async
        END IF
     ENDIF
Index: codes/icosagcm/trunk/src/dissip/dissip_gcm.F90
===================================================================
--- codes/icosagcm/trunk/src/dissip/dissip_gcm.F90	(revision 962)
+++ codes/icosagcm/trunk/src/dissip/dissip_gcm.F90	(revision 963)
@@ -4,10 +4,10 @@
   PRIVATE
 
-  TYPE(t_field),POINTER,SAVE :: f_due_diss1(:)
-  TYPE(t_field),POINTER,SAVE :: f_due_diss2(:)
+  TYPE(t_field),POINTER,SAVE :: f_due_diss_gradiv(:)
+  TYPE(t_field),POINTER,SAVE :: f_due_diss_gradrot(:)
 
   TYPE(t_field),POINTER,SAVE :: f_dtheta_diss(:)
   TYPE(t_field),POINTER,SAVE :: f_dtheta_rhodz_diss(:)
-  TYPE(t_message),SAVE :: req_due, req_dtheta 
+  TYPE(t_message),SAVE :: req_due_gradiv, req_due_gradrot, req_dtheta 
  
   INTEGER,SAVE :: nitergdiv=1
@@ -47,7 +47,7 @@
   SUBROUTINE allocate_dissip
   USE icosa
-  IMPLICIT NONE  
-    CALL allocate_field(f_due_diss1,field_u,type_real,llm,ondevice=.TRUE.)
-    CALL allocate_field(f_due_diss2,field_u,type_real,llm,ondevice=.TRUE.)
+  IMPLICIT NONE
+    CALL allocate_field(f_due_diss_gradiv,field_u,type_real,llm,ondevice=.TRUE.)
+    CALL allocate_field(f_due_diss_gradrot,field_u,type_real,llm,ondevice=.TRUE.)
     CALL allocate_field(f_dtheta_diss,field_t,type_real,llm)
     CALL allocate_field(f_dtheta_rhodz_diss,field_t,type_real,llm,ondevice=.TRUE.)
@@ -140,6 +140,7 @@
     CALL allocate_field(f_dtheta,field_t,type_real,ondevice=.TRUE.)
     
-    CALL init_message(f_due_diss1,req_e1_vect,req_due)
-    CALL init_message(f_dtheta_diss,req_i1,req_dtheta)
+    CALL init_message(f_due_diss_gradiv,req_e1_vect,req_due_gradiv)
+    CALL init_message(f_due_diss_gradrot,req_e1_vect,req_due_gradrot)
+    CALL init_message(f_dtheta_rhodz_diss,req_i1,req_dtheta)
 
     tau_graddiv(:)=5000
@@ -548,6 +549,6 @@
     
     CALL trace_start("dissip")
-    CALL gradiv(f_ue,f_due_diss1)
-    CALL gradrot(f_ue,f_due_diss2)
+    CALL gradiv(f_ue,f_due_diss_gradiv)
+    CALL gradrot(f_ue,f_due_diss_gradrot)
 
     CALL divgrad_theta_rhodz(f_mass,f_theta_rhodz,f_dtheta_rhodz_diss)
@@ -558,6 +559,6 @@
       CALL swap_geometry(ind)
       due=f_due(ind) 
-      due_diss1=f_due_diss1(ind)
-      due_diss2=f_due_diss2(ind)
+      due_diss1=f_due_diss_gradiv(ind)
+      due_diss2=f_due_diss_gradrot(ind)
       dtheta_rhodz=f_dtheta_rhodz(ind)
       dtheta_rhodz_diss=f_dtheta_rhodz_diss(ind)
@@ -653,11 +654,11 @@
          USE output_field_mod
 
-         CALL transfert_request(f_due_diss1,req_e1_vect)
-         CALL un2ulonlat(f_due_diss1, f_buf_ulon, f_buf_ulat, (1./(tau_graddiv(1))))
+         CALL transfert_request(f_due_diss_gradiv,req_e1_vect)
+         CALL un2ulonlat(f_due_diss_gradiv, f_buf_ulon, f_buf_ulat, (1./(tau_graddiv(1))))
          CALL output_field("dulon_diss1",f_buf_ulon)
          CALL output_field("dulat_diss1",f_buf_ulat)
 !
-         CALL transfert_request(f_due_diss2,req_e1_vect)
-         CALL un2ulonlat(f_due_diss2, f_buf_ulon, f_buf_ulat, (1./(tau_graddiv(1))))
+         CALL transfert_request(f_due_diss_gradrot,req_e1_vect)
+         CALL un2ulonlat(f_due_diss_gradrot, f_buf_ulon, f_buf_ulat, (1./(tau_graddiv(1))))
          CALL output_field("dulon_diss2",f_buf_ulon)
          CALL output_field("dulat_diss2",f_buf_ulat)
@@ -699,7 +700,6 @@
 
     DO it=1,nitergdiv
-      CALL send_message(f_due,req_due)
-      CALL wait_message(req_due)
-
+      CALL send_message(f_due,req_due_gradiv)
+      CALL wait_message(req_due_gradiv)
       DO ind=1,ndomain
         IF (.NOT. assigned_domain(ind)) CYCLE
@@ -749,6 +749,6 @@
 
     DO it=1,nitergrot
-      CALL send_message(f_due,req_due)
-      CALL wait_message(req_due)
+      CALL send_message(f_due,req_due_gradrot)
+      CALL wait_message(req_due_gradrot)
         
       DO ind=1,ndomain
Index: codes/icosagcm/trunk/src/output/write_field.f90
===================================================================
--- codes/icosagcm/trunk/src/output/write_field.f90	(revision 962)
+++ codes/icosagcm/trunk/src/output/write_field.f90	(revision 963)
@@ -66,5 +66,5 @@
     USE domain_mod
     USE field_mod
-    USE transfert_mpi_mod
+    USE transfert_mod
     USE dimensions
     USE mpipara
Index: codes/icosagcm/trunk/src/parallel/domain.f90
===================================================================
--- codes/icosagcm/trunk/src/parallel/domain.f90	(revision 962)
+++ codes/icosagcm/trunk/src/parallel/domain.f90	(revision 963)
@@ -694,4 +694,6 @@
     
     ENDDO
+
+    !$acc enter data copyin(assigned_domain(:))
     
   END SUBROUTINE assign_domain_omp
Index: codes/icosagcm/trunk/src/parallel/transfert.F90
===================================================================
--- codes/icosagcm/trunk/src/parallel/transfert.F90	(revision 962)
+++ codes/icosagcm/trunk/src/parallel/transfert.F90	(revision 963)
@@ -1,38 +1,89 @@
-MODULE transfert_mod
-
+module transfert_mod
 #ifdef CPP_USING_MPI
-  USE transfert_mpi_mod, ONLY : init_transfert, transfert_request=>transfert_request_mpi, req_i1,req_e1_vect, &
-                                req_e1_scal, req_z1_scal, req_i0, req_e0_vect, req_e0_scal, request_add_point,             &
-                                create_request, gather_field, scatter_field,         &
-                                t_message, init_message=>init_message_mpi,           &
-                                transfert_message=>transfert_message_mpi,            &
-                                send_message=>send_message_mpi,                      &
-                                test_message=>test_message_mpi,                      &
-                                wait_message=>wait_message_mpi,barrier,bcast_mpi
-#else 
-  USE transfert_mpi_mod, ONLY : init_transfert, transfert_request=>transfert_request_seq, req_i1,req_e1_vect, &
-                                req_e1_scal, req_z1_scal, req_i0, req_e0_vect, req_e0_scal,        &
-                                request_add_point, create_request, gather_field,     &
-                                scatter_field, t_message,                            &
-                                init_message=>init_message_seq,                      &
-                                transfert_message=>transfert_message_seq,            &
-                                send_message=>send_message_seq,                      &
-                                test_message=>test_message_seq,                      &
-                                wait_message=>wait_message_seq,barrier, bcast_mpi
+
+#if defined(CPP_USING_MPI_LEGACY)
+#warning("Using legacy transfert_mpi (not default)")
+  use transfert_mpi_legacy_mod, only :  t_message, t_request, &
+                                        req_i1, req_e1_scal, req_e1_vect, &
+                                        req_i0, req_e0_scal, req_e0_vect, &
+                                        req_z1_scal, &
+                                        init_transfert, &
+                                        init_message => init_message_mpi, &
+                                        finalize_message => finalize_message_mpi, &
+                                        send_message => send_message_mpi, &
+                                        wait_message => wait_message_mpi, &
+                                        test_message => test_message_mpi
+#else
+  ! transfert_mpi using manual pack/unpack (default)
+  use transfert_mpi_mod, only : t_message, t_request, &
+                                req_i1, req_e1_scal, req_e1_vect, &
+                                req_i0, req_e0_scal, req_e0_vect, &
+                                req_z1_scal, &
+                                init_transfert, &
+                                init_message, &
+                                finalize_message, &
+                                send_message, &
+                                wait_message, &
+                                test_message
 #endif
-
-  USE transfert_omp_mod
-  
-  INTERFACE bcast
-    MODULE PROCEDURE bcast_c,                                     &
-                     bcast_i,bcast_i1,bcast_i2,bcast_i3,bcast_i4, &
-                     bcast_r,bcast_r1,bcast_r2,bcast_r3,bcast_r4, &
-		     bcast_l,bcast_l1,bcast_l2,bcast_l3,bcast_l4
-
-  END INTERFACE
-
-
-CONTAINS
-
+#else
+#warning("Using transfert_seq (unmaintained)")
+  use transfert_mpi_legacy_mod, only :  t_message, t_request, &
+                                        req_i1, req_e1_scal, req_e1_vect, &
+                                        req_i0, req_e0_scal, req_e0_vect, &
+                                        req_z1_scal, &
+                                        init_transfert, &
+                                        init_message=>init_message_seq, &
+                                        finalize_message => finalize_message_seq, &
+                                        send_message => send_message_seq, &
+                                        wait_message => wait_message_seq, &
+                                        test_message => test_message_seq
+#endif
+  use transfert_mpi_collectives_mod, only : gather_field, scatter_field, bcast_field, bcast_mpi
+  use transfert_omp_mod, only : bcast_omp
+
+  implicit none
+  private
+  public :: t_message, t_request, &
+          req_i1, req_e1_scal, req_e1_vect, &
+          req_i0, req_e0_scal, req_e0_vect, &
+          !req_z1_scal, &
+          init_transfert, &
+          init_message, &
+          finalize_message, &
+          send_message, &
+          wait_message, &
+          test_message, &
+          transfert_request, &
+          transfert_message, &
+          gather_field, scatter_field, bcast_field, bcast, bcast_omp
+
+  interface bcast
+    module procedure  bcast_c,                                     &
+                      bcast_i,bcast_i1,bcast_i2,bcast_i3,bcast_i4, &
+                      bcast_r,bcast_r1,bcast_r2,bcast_r3,bcast_r4, &
+                      bcast_l,bcast_l1,bcast_l2,bcast_l3,bcast_l4
+  end interface
+
+contains
+  subroutine transfert_message(field, message)
+    use field_mod, only : t_field
+    type(t_field), pointer :: field(:)
+    type(t_message) :: message
+
+    call send_message(field, message)
+    call wait_message(message)
+  end subroutine
+
+  subroutine transfert_request(field, request)
+    use field_mod, only : t_field
+    type(t_field),pointer :: field(:)
+    type(t_request),pointer :: request(:)
+    type(t_message), save :: message ! Save because shared between threads
+
+    call init_message(field, request, message)
+    call transfert_message(field, message)
+    call finalize_message(message)
+  end subroutine
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -40,5 +91,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-!! -- Les chaine de charactère -- !!
+!! -- Les chaine de charactï¿œre -- !!
 
   SUBROUTINE bcast_c(var)
